---
title: "Secondary Axes"
framework: javascript
version: "14.1.0"
---

# Secondary Axes

Secondary axes are typically used to compare data sets with different scales, with extra axes usually located on the opposite side of the chart.

## Creating a Secondary Axis

The easiest way to create a secondary axis is by assigning a series to an axis key with the `series[].yKeyAxis` property.

If a series provides a `yKeyAxis` value, and no axis exists for that key, a new axis with default properties will be automatically created.

The second `y` axis will be positioned to the `'right'` by default.

This allows you to create and use a secondary axis without any explicit axis configuration.

#### Secondary y-axis

```ts
import {
  AgChartOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const options: AgChartOptions = {
  data: getData(),
  title: {
    text: "Cattle Holdings and Beef Exports (UK)",
    fontSize: 18,
  },
  subtitle: {
    text: "Source: Department for Environment, Food & Rural Affairs",
  },
  series: [
    {
      type: "bar",
      xKey: "year",
      yKey: "male",
      yName: "Male cattle",
    },
    {
      type: "bar",
      xKey: "year",
      yKey: "female",
      yName: "Female cattle",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "exportedTonnes",
      yName: "Beef exports",
      yKeyAxis: "ySecondary",
      strokeWidth: 5,
      marker: {
        enabled: false,
      },
    },
  ],
  axes: {
    y: {
      type: "number",
      position: "left",
      title: {
        text: "Number of cattle",
      },
      label: {
        formatter: (params) => {
          return params.value / 1000 + "M";
        },
      },
    },
    ySecondary: {
      type: "number",
      position: "right",
      title: {
        text: "Exports (tonnes)",
      },
      label: {
        formatter: (params) => {
          return params.value / 1000 + "k";
        },
      },
    },
  },
  legend: {
    item: {
      marker: {
        shape: "square",
        strokeWidth: 0,
      },
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Secondary y-axis](https://www.ag-grid.com/charts/archive/14.1.0/typescript/axes-secondary/examples/multiple-axes)

In this example:

- The `bar` series do not specify a `yKeyAxis`, so they are linked to the default `y` axis.
- The `line` series specifies `yKeyAxis: 'ySecondary'`, which automatically creates a new secondary axis on the right.
- Any number of `y` axes can be created in this way and the same concept applies to x-axes using the `xKeyAxis` property.

```js
{
    series: [
        // These two series are linked to the default 'y' axis
        { type: 'bar', xKey: 'year', yKey: 'male' },
        { type: 'bar', xKey: 'year', yKey: 'female' },

        // This series is linked to a new, automatically created 'ySecondary' axis
        {
            type: 'line',
            xKey: 'year',
            yKey: 'exportedTonnes',
            yKeyAxis: 'ySecondary',
        },
    ],
}
```

## Configuring Axes

Automatic creation is useful in many cases, but explicit axis configuration is often required, for example to add a title or change its position.

To do this, the configured axes are declared in the `axes` property. The keys used here must match the keys used by the `yKeyAxis` property on the series.

```js
{
    axes: {
        y: {
            // This configures the default y-axis
            type: 'number',
            position: 'left',
            title: { text: 'Number of cattle' },
        },
        ySecondary: {
            // This configures the 'ySecondary' used by the line series
            type: 'number',
            position: 'right',
            title: { text: 'Exports (tonnes)' },
        },
    },
}
```

## Custom Axis Keys

The above example used the default `y` key and an additional key of `ySecondary`.

To increase readability, especially when dealing with multiple axes with distinct meanings, more descriptive axis keys should be used.

Series are linked to axes by supplying an axis key in the series configuration using the `xKeyAxis`, `yKeyAxis` and similar properties.

The axis key supplied to the series does not need to be used in the `axes` options if no customisation is required.

```js
{
    series: [
        { type: 'bar', xKey: 'month', yKey: 'profit', yKeyAxis: 'profit' },
        { type: 'line', xKey: 'month', yKey: 'revenue', yKeyAxis: 'revenue' },
    ],
    axes: {
        revenue: { type: 'number', position: 'right', title: { text: 'revenue' } },
        profit: { type: 'number', position: 'left', title: { text: 'profit' } },
    },
}
```

In this configuration:

- The `yKey` values of the first series are plotted against the `profit` axis on the left, whilst the `yKey` values of the second series are plotted against the `revenue` axis on the right.
- Series default to the `x` and `y` axis keys when not specified, so `series[].xKeyAxis` is not required.
- `axes.x` is not required because no customisation is needed for the default x-axis.
- There is no `axes.y` in this chart as all series have specified a different `yKeyAxis`.

Specifying `type` is not required but is recommended for type-checking and validation.

The `position` property is also optional. The first secondary y-axis will automatically be placed on the right, with subsequent axes alternating to the left. Without explicit `position` or series axis key properties, the chart may misidentify or misplace axes, so specifying `position` is recommended.


---
title: "Secondary Axes"
framework: vue
version: "14.1.0"
---

# Secondary Axes

Secondary axes are typically used to compare data sets with different scales, with extra axes usually located on the opposite side of the chart.

## Creating a Secondary Axis

The easiest way to create a secondary axis is by assigning a series to an axis key with the `series[].yKeyAxis` property.

If a series provides a `yKeyAxis` value, and no axis exists for that key, a new axis with default properties will be automatically created.

The second `y` axis will be positioned to the `'right'` by default.

This allows you to create and use a secondary axis without any explicit axis configuration.

#### Secondary y-axis

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions>({
      data: getData(),
      title: {
        text: "Cattle Holdings and Beef Exports (UK)",
        fontSize: 18,
      },
      subtitle: {
        text: "Source: Department for Environment, Food & Rural Affairs",
      },
      series: [
        {
          type: "bar",
          xKey: "year",
          yKey: "male",
          yName: "Male cattle",
        },
        {
          type: "bar",
          xKey: "year",
          yKey: "female",
          yName: "Female cattle",
        },
        {
          type: "line",
          xKey: "year",
          yKey: "exportedTonnes",
          yName: "Beef exports",
          yKeyAxis: "ySecondary",
          strokeWidth: 5,
          marker: {
            enabled: false,
          },
        },
      ],
      axes: {
        y: {
          type: "number",
          position: "left",
          title: {
            text: "Number of cattle",
          },
          label: {
            formatter: (params) => {
              return params.value / 1000 + "M";
            },
          },
        },
        ySecondary: {
          type: "number",
          position: "right",
          title: {
            text: "Exports (tonnes)",
          },
          label: {
            formatter: (params) => {
              return params.value / 1000 + "k";
            },
          },
        },
      },
      legend: {
        item: {
          marker: {
            shape: "square",
            strokeWidth: 0,
          },
        },
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Secondary y-axis](https://www.ag-grid.com/charts/archive/14.1.0/vue3/axes-secondary/examples/multiple-axes)

In this example:

- The `bar` series do not specify a `yKeyAxis`, so they are linked to the default `y` axis.
- The `line` series specifies `yKeyAxis: 'ySecondary'`, which automatically creates a new secondary axis on the right.
- Any number of `y` axes can be created in this way and the same concept applies to x-axes using the `xKeyAxis` property.

```js
{
    series: [
        // These two series are linked to the default 'y' axis
        { type: 'bar', xKey: 'year', yKey: 'male' },
        { type: 'bar', xKey: 'year', yKey: 'female' },

        // This series is linked to a new, automatically created 'ySecondary' axis
        {
            type: 'line',
            xKey: 'year',
            yKey: 'exportedTonnes',
            yKeyAxis: 'ySecondary',
        },
    ],
}
```

## Configuring Axes

Automatic creation is useful in many cases, but explicit axis configuration is often required, for example to add a title or change its position.

To do this, the configured axes are declared in the `axes` property. The keys used here must match the keys used by the `yKeyAxis` property on the series.

```js
{
    axes: {
        y: {
            // This configures the default y-axis
            type: 'number',
            position: 'left',
            title: { text: 'Number of cattle' },
        },
        ySecondary: {
            // This configures the 'ySecondary' used by the line series
            type: 'number',
            position: 'right',
            title: { text: 'Exports (tonnes)' },
        },
    },
}
```

## Custom Axis Keys

The above example used the default `y` key and an additional key of `ySecondary`.

To increase readability, especially when dealing with multiple axes with distinct meanings, more descriptive axis keys should be used.

Series are linked to axes by supplying an axis key in the series configuration using the `xKeyAxis`, `yKeyAxis` and similar properties.

The axis key supplied to the series does not need to be used in the `axes` options if no customisation is required.

```js
{
    series: [
        { type: 'bar', xKey: 'month', yKey: 'profit', yKeyAxis: 'profit' },
        { type: 'line', xKey: 'month', yKey: 'revenue', yKeyAxis: 'revenue' },
    ],
    axes: {
        revenue: { type: 'number', position: 'right', title: { text: 'revenue' } },
        profit: { type: 'number', position: 'left', title: { text: 'profit' } },
    },
}
```

In this configuration:

- The `yKey` values of the first series are plotted against the `profit` axis on the left, whilst the `yKey` values of the second series are plotted against the `revenue` axis on the right.
- Series default to the `x` and `y` axis keys when not specified, so `series[].xKeyAxis` is not required.
- `axes.x` is not required because no customisation is needed for the default x-axis.
- There is no `axes.y` in this chart as all series have specified a different `yKeyAxis`.

Specifying `type` is not required but is recommended for type-checking and validation.

The `position` property is also optional. The first secondary y-axis will automatically be placed on the right, with subsequent axes alternating to the left. Without explicit `position` or series axis key properties, the chart may misidentify or misplace axes, so specifying `position` is recommended.


---
title: "Secondary Axes"
framework: react
version: "14.1.0"
---

# Secondary Axes

Secondary axes are typically used to compare data sets with different scales, with extra axes usually located on the opposite side of the chart.

## Creating a Secondary Axis

The easiest way to create a secondary axis is by assigning a series to an axis key with the `series[].yKeyAxis` property.

If a series provides a `yKeyAxis` value, and no axis exists for that key, a new axis with default properties will be automatically created.

The second `y` axis will be positioned to the `'right'` by default.

This allows you to create and use a secondary axis without any explicit axis configuration.

#### Secondary y-axis

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions>({
    data: getData(),
    title: {
      text: "Cattle Holdings and Beef Exports (UK)",
      fontSize: 18,
    },
    subtitle: {
      text: "Source: Department for Environment, Food & Rural Affairs",
    },
    series: [
      {
        type: "bar",
        xKey: "year",
        yKey: "male",
        yName: "Male cattle",
      },
      {
        type: "bar",
        xKey: "year",
        yKey: "female",
        yName: "Female cattle",
      },
      {
        type: "line",
        xKey: "year",
        yKey: "exportedTonnes",
        yName: "Beef exports",
        yKeyAxis: "ySecondary",
        strokeWidth: 5,
        marker: {
          enabled: false,
        },
      },
    ],
    axes: {
      y: {
        type: "number",
        position: "left",
        title: {
          text: "Number of cattle",
        },
        label: {
          formatter: (params) => {
            return params.value / 1000 + "M";
          },
        },
      },
      ySecondary: {
        type: "number",
        position: "right",
        title: {
          text: "Exports (tonnes)",
        },
        label: {
          formatter: (params) => {
            return params.value / 1000 + "k";
          },
        },
      },
    },
    legend: {
      item: {
        marker: {
          shape: "square",
          strokeWidth: 0,
        },
      },
    },
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Secondary y-axis](https://www.ag-grid.com/charts/archive/14.1.0/reactFunctionalTs/axes-secondary/examples/multiple-axes)

In this example:

- The `bar` series do not specify a `yKeyAxis`, so they are linked to the default `y` axis.
- The `line` series specifies `yKeyAxis: 'ySecondary'`, which automatically creates a new secondary axis on the right.
- Any number of `y` axes can be created in this way and the same concept applies to x-axes using the `xKeyAxis` property.

```js
{
    series: [
        // These two series are linked to the default 'y' axis
        { type: 'bar', xKey: 'year', yKey: 'male' },
        { type: 'bar', xKey: 'year', yKey: 'female' },

        // This series is linked to a new, automatically created 'ySecondary' axis
        {
            type: 'line',
            xKey: 'year',
            yKey: 'exportedTonnes',
            yKeyAxis: 'ySecondary',
        },
    ],
}
```

## Configuring Axes

Automatic creation is useful in many cases, but explicit axis configuration is often required, for example to add a title or change its position.

To do this, the configured axes are declared in the `axes` property. The keys used here must match the keys used by the `yKeyAxis` property on the series.

```js
{
    axes: {
        y: {
            // This configures the default y-axis
            type: 'number',
            position: 'left',
            title: { text: 'Number of cattle' },
        },
        ySecondary: {
            // This configures the 'ySecondary' used by the line series
            type: 'number',
            position: 'right',
            title: { text: 'Exports (tonnes)' },
        },
    },
}
```

## Custom Axis Keys

The above example used the default `y` key and an additional key of `ySecondary`.

To increase readability, especially when dealing with multiple axes with distinct meanings, more descriptive axis keys should be used.

Series are linked to axes by supplying an axis key in the series configuration using the `xKeyAxis`, `yKeyAxis` and similar properties.

The axis key supplied to the series does not need to be used in the `axes` options if no customisation is required.

```js
{
    series: [
        { type: 'bar', xKey: 'month', yKey: 'profit', yKeyAxis: 'profit' },
        { type: 'line', xKey: 'month', yKey: 'revenue', yKeyAxis: 'revenue' },
    ],
    axes: {
        revenue: { type: 'number', position: 'right', title: { text: 'revenue' } },
        profit: { type: 'number', position: 'left', title: { text: 'profit' } },
    },
}
```

In this configuration:

- The `yKey` values of the first series are plotted against the `profit` axis on the left, whilst the `yKey` values of the second series are plotted against the `revenue` axis on the right.
- Series default to the `x` and `y` axis keys when not specified, so `series[].xKeyAxis` is not required.
- `axes.x` is not required because no customisation is needed for the default x-axis.
- There is no `axes.y` in this chart as all series have specified a different `yKeyAxis`.

Specifying `type` is not required but is recommended for type-checking and validation.

The `position` property is also optional. The first secondary y-axis will automatically be placed on the right, with subsequent axes alternating to the left. Without explicit `position` or series axis key properties, the chart may misidentify or misplace axes, so specifying `position` is recommended.


Secondary axes are typically used to compare data sets with different scales, with extra axes usually located on the opposite side of the chart.
Creating a Secondary Axis Copy Link
The easiest way to create a secondary axis is by assigning a series to an axis key with the series[].yKeyAxis property.
If a series provides a yKeyAxis value, and no axis exists for that key, a new axis with default properties will be automatically created.
The second y axis will be positioned to the 'right' by default.
This allows you to create and use a secondary axis without any explicit axis configuration.
import { Component } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgChartOptions,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
constructor() {
this.options = {
data: getData(),
title: {
text: "Cattle Holdings and Beef Exports (UK)",
fontSize: 18,
},
subtitle: {
text: "Source: Department for Environment, Food & Rural Affairs",
},
series: [
{
type: "bar",
xKey: "year",
yKey: "male",
yName: "Male cattle",
},
{
type: "bar",
xKey: "year",
yKey: "female",
yName: "Female cattle",
},
{
type: "line",
xKey: "year",
yKey: "exportedTonnes",
yName: "Beef exports",
yKeyAxis: "ySecondary",
strokeWidth: 5,
marker: {
enabled: false,
},
},
],
axes: {
y: {
type: "number",
position: "left",
title: {
text: "Number of cattle",
},
label: {
formatter: (params) => {
return params.value / 1000 + "M";
},
},
},
ySecondary: {
type: "number",
position: "right",
title: {
text: "Exports (tonnes)",
},
label: {
formatter: (params) => {
return params.value / 1000 + "k";
},
},
},
},
legend: {
item: {
marker: {
shape: "square",
strokeWidth: 0,
},
},
},
};
}
}
// Source: https://www.gov.uk/government/statistical-data-sets/structure-of-the-livestock-industry-in-england-at-december
// Source: http://beefandlamb.ahdb.org.uk/markets/industry-reports/uk-statistics/
export function getData(): any[] {
return [
{ year: "2013", male: 1480, female: 3843, exportedTonnes: 105311 },
{ year: "2014", male: 1440, female: 3868, exportedTonnes: 112260 },
{ year: "2015", male: 1457, female: 3900, exportedTonnes: 100491 },
{ year: "2016", male: 1460, female: 3895, exportedTonnes: 110428 },
{ year: "2017", male: 1456, female: 3891, exportedTonnes: 105601 },
{ year: "2018", male: 1425, female: 3837, exportedTonnes: 110508 },
{ year: "2019", male: 1371, female: 3775, exportedTonnes: 135198 },
];
}
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
In this example:
- The
barseries do not specify ayKeyAxis, so they are linked to the defaultyaxis. - The
lineseries specifiesyKeyAxis: 'ySecondary', which automatically creates a new secondary axis on the right. - Any number of
yaxes can be created in this way and the same concept applies to x-axes using thexKeyAxisproperty.
{
series: [
// These two series are linked to the default 'y' axis
{ type: 'bar', xKey: 'year', yKey: 'male' },
{ type: 'bar', xKey: 'year', yKey: 'female' },
// This series is linked to a new, automatically created 'ySecondary' axis
{
type: 'line',
xKey: 'year',
yKey: 'exportedTonnes',
yKeyAxis: 'ySecondary',
},
],
} Configuring Axes Copy Link
Automatic creation is useful in many cases, but explicit axis configuration is often required, for example to add a title or change its position.
To do this, the configured axes are declared in the axes property. The keys used here must match the keys used by the yKeyAxis property on the series.
{
axes: {
y: {
// This configures the default y-axis
type: 'number',
position: 'left',
title: { text: 'Number of cattle' },
},
ySecondary: {
// This configures the 'ySecondary' used by the line series
type: 'number',
position: 'right',
title: { text: 'Exports (tonnes)' },
},
},
} Custom Axis Keys Copy Link
The above example used the default y key and an additional key of ySecondary.
To increase readability, especially when dealing with multiple axes with distinct meanings, more descriptive axis keys should be used.
Series are linked to axes by supplying an axis key in the series configuration using the xKeyAxis, yKeyAxis and similar properties.
The axis key supplied to the series does not need to be used in the axes options if no customisation is required.
{
series: [
{ type: 'bar', xKey: 'month', yKey: 'profit', yKeyAxis: 'profit' },
{ type: 'line', xKey: 'month', yKey: 'revenue', yKeyAxis: 'revenue' },
],
axes: {
revenue: { type: 'number', position: 'right', title: { text: 'revenue' } },
profit: { type: 'number', position: 'left', title: { text: 'profit' } },
},
}In this configuration:
- The
yKeyvalues of the first series are plotted against theprofitaxis on the left, whilst theyKeyvalues of the second series are plotted against therevenueaxis on the right. - Series default to the
xandyaxis keys when not specified, soseries[].xKeyAxisis not required. axes.xis not required because no customisation is needed for the default x-axis.- There is no
axes.yin this chart as all series have specified a differentyKeyAxis.
Specifying type is not required but is recommended for type-checking and validation.
The position property is also optional. The first secondary y-axis will automatically be placed on the right, with subsequent axes alternating to the left. Without explicit position or series axis key properties, the chart may misidentify or misplace axes, so specifying position is recommended.